var score_id = "cricketfox";
var tool_id="cricketpop";
var score_url = "http://www.cricinfo.com/rss/livescores.xml";
var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
var alertService = Components.classes["@mozilla.org/alerts-service;1"].getService(Components.interfaces.nsIAlertsService);
// This is our javascript

var objCricketFox = null;

function cfLoad() {

	objCricketFox = new CricketFox();
	objCricketFox.lastUpdate.setDate(objCricketFox.lastUpdate.getDate()-5);
	objCricketFox.do_score();
}


function CricketFox () {
	
	return this;
}

function cfLoadOptions() {
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                       .getService(Components.interfaces.nsIWindowMediator);
    var win = wm.getMostRecentWindow("Cricketfox:Options");
    if (win) {
		win.focus();
	} else {
		openDialog("chrome://cricketfox/content/options.xul", "", "chrome,titlebar,toolbar,centerscreen,modal");
	}
}

CricketFox.prototype =
{
	oldwickets:-1,
	lastUpdate:new Date(),
	favTeam:prefService.getCharPref("extensions.cricketfox.favTeam"),
	request: null,
	do_score: function(){
		this.favTeam = prefService.getCharPref("extensions.cricketfox.favTeam"),
		this.load_xml(score_url);
		setTimeout("objCricketFox.do_score()", prefService.getIntPref("extensions.cricketfox.updateInterval"));
	},

	// Adapted from the good people at ADC:
	// http://developer.apple.com/internet/webcontent/xmlhttpreq.html
	// this starts loading the XML data and sets up the process_request handler.
	load_xml: function(url)
	{
		var module = this;
		this.request = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance(Components.interfaces.nsIXMLHttpRequest);;
	    this.request.open("GET", url, true);
		this.request.overrideMimeType("text/xml");
	    this.request.onload = function() { module.process_request(this.responseXML, this.status) };
    	try {
	      if (this.request.channel instanceof Components.interfaces.nsISupportsPriority)
    	    this.request.channel.priority = Components.interfaces.nsISupportsPriority.PRIORITY_HIGHEST;
	    } catch(e) {};
        this.request.send(null);	
	},

	// This function is called once the request state changes.  It pulls the
	// relevant data from the response and sends to update_count().
	process_request: function(response, aStatus)
	{
		if (!response || aStatus > 200) {
	      return;
	    };

			var pubDate = Date.parse(response.getElementsByTagName('pubDate')[0].firstChild.data);
			var items = response.getElementsByTagName('item');
				for(var loop=0;loop < items.length;loop++){
					var title = items[loop].getElementsByTagName('title')[0].firstChild.data;
					if(title.match(objCricketFox.favTeam)!=null){
					//Match for your favourite team.
						var regex = new RegExp("\\([a-zA-Z0-9.'/\\s]*\\)","g");
						var newTitle = title.replace(regex,"");
						document.getElementById(score_id).setAttribute("label", newTitle);
						var teams = newTitle.split("Vs");
						var detailsLink = items[loop].getElementsByTagName('link')[0].firstChild.data;
						var team1 = teams[0].trim();
						var team2 = teams[1].trim();																				 
						var isHomeBatting = 0;
						if(team1.indexOf('*')!=-1){
						//First team batting, show their score	
							isHomeBatting = 1;
							team1 = team1.substring(0,team1.indexOf("*")).trim();
							objCricketFox.update_score(team1,team2,isHomeBatting,detailsLink);
						}
						else{
						//Second team batting show them.	
							team2 = team2.substring(0,team2.indexOf("*")).trim();				
							objCricketFox.update_score(team2,team1,isHomeBatting,detailsLink);
						}
					}
//			var func = "objCricketFox.eventPopup(pubDate);";
			//delay slider to avoid complications
		//	setTimeout(func, 2000);	
  			}
	},
	
	eventPopup: function (message) {
		var url = "http://localhost:8080/engSmall.png";
		var slogan = "WICKET!!";
		alertService.showAlertNotification(url,slogan, message,false,"",null);

	},

	update_score: function(battingTeam, otherTeam,isHomeBatting, detailsLink)
	{
	
  		var score = document.getElementById(score_id);
		//Set the visible label
  		score.setAttribute("label", battingTeam);
		score.setAttribute("ondblclick","window.open('"+detailsLink+"');");
		//Do the tooltip info
  		var parent = document.getElementById("cricketpop");
		//Get old tooltip so that it can be replaced
  		var oldTooltip = document.getElementById("scoretip");
	  	var tooltip = document.createElement("tooltip");
  		tooltip.setAttribute("id", "scoretip");
  		tooltip.setAttribute("orient","horizontal");
		tooltip.setAttribute("noautohide", "true");

		//Create the image
		var image = document.createElement("image");
		var icon = "chrome://cricketfox/skin/images/cficonsmall.png";
		image.setAttribute("src", icon);
		var imgparent = document.createElement("vbox");
	        imgparent.appendChild(image);
	
		//Create the score labels
  		var lblparent = document.createElement("vbox");

  		var lbl = document.createElement("label");
  		lbl.setAttribute("crop", "right");
	  	
  		var lbl1 = document.createElement("label");
  		lbl1.setAttribute("crop", "right");         
		if(isHomeBatting==1){
			lbl.setAttribute("value", battingTeam);
	  		lbl1.setAttribute("value", otherTeam);
		}       
		else{
			lbl.setAttribute("value", otherTeam);
	  		lbl1.setAttribute("value", battingTeam);
		}       
 	 	lblparent.appendChild(lbl);
  		lblparent.appendChild(lbl1);

  		tooltip.appendChild(imgparent); 
  		tooltip.appendChild(lblparent); 
		
  		parent.replaceChild(tooltip,oldTooltip);    
 		score.setAttribute("tooltip","scoretip");
	}
};